/*
* Copyright (C) 2009 Mamadou Diop.
*
* Contact: Mamadou Diop <diopmamadou(at)doubango.org>
*	
* This file is part of Open Source Doubango Framework.
*
* DOUBANGO is free software: you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation, either version 3 of the License, or
* (at your option) any later version.
*	
* DOUBANGO is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*	
* You should have received a copy of the GNU General Public License
* along with DOUBANGO.
*
*/

/**@file tipsec.c
 * @brief IPSec manager.
 *
 * @author Mamadou Diop <diopmamadou(at)doubango.org>
 *
 * @date Created: Sat Nov 8 16:54:58 2009 mdiop
 */
#include "tipsec.h"

/** @mainpage TinyIPSec API Overview
*
* This file is an overview of TinyIPSec API.
*
* <b>tinyIPSec</b> is responsible for IPSec SAs managment. It is used in conjunction with security agreement mechanism (RFC 3329)
* to create, manage and terminate SAs. <br>
*
* @par Getting started
*
* - @ref tipsec_common_group
*
* - @ref tipsec_xp_group
* - @ref tipsec_vista_group
* - @ref tipsec_racoon_group
*
*/
