/*
* Copyright (C) 2009 Mamadou Diop.
*
* Contact: Mamadou Diop <diopmamadou(at)doubango.org>
*	
* This file is part of Open Source Doubango Framework.
*
* DOUBANGO is free software: you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation, either version 3 of the License, or
* (at your option) any later version.
*	
* DOUBANGO is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*	
* You should have received a copy of the GNU General Public License
* along with DOUBANGO.
*
*/

/**@file tsip_api_common.h
 * @brief Public common functions.
 *
 * @author Mamadou Diop <diopmamadou(at)doubango.org>
 *
 * @date Created: Sat Nov 8 16:54:58 2009 mdiop
 */
#ifndef TINYSIP_TSIP_COMMON_H
#define TINYSIP_TSIP_COMMON_H

#include "tinysip_config.h"

#include "tinysip/tsip_ssession.h"

TSIP_BEGIN_DECLS

TINYSIP_API int tsip_action_REJECT(const tsip_ssession_handle_t *ss, ...);
TINYSIP_API int tsip_action_HANGUP(const tsip_ssession_handle_t *ss, ...);
TINYSIP_API int tsip_action_ACCEPT(const tsip_ssession_handle_t *ss, ...);

TSIP_END_DECLS

#endif /* TINYSIP_TSIP_COMMON_H */
